create or replace package body DEPENDENCY_INJECTOR is

  procedure inject_dependencies
  is
  begin
    -- loop over all properties that are configured in table CONFIGURATION_VALUES
    for r in (select cve.package_name
              ,      cve.property
              ,      cve.value
              from   configuration_values cve
              ) loop
      -- for each property               
      execute immediate 'begin '||r.package_name||'.set_'||r.property||'(:1); end;' 
        using r.value;                      
    end loop;
  end inject_dependencies;

end DEPENDENCY_INJECTOR;
/
