create or replace package HRM_SALARY_RULES is

  C_VALIDATION_FAILURE_EVENT CONSTANT varchar2(30) := 'validation_failure';
  C_PERFORMANCE_LOSS_EVENT CONSTANT varchar2(30) := 'performance_loss';
  C_SALARY_DECREASE_EVENT CONSTANT varchar2(30) := 'salary_decrease';

  procedure register_observer
  (  p_observer   in varchar2              -- name of a procedure that can be invoked to consume an event; its specification should be like 
                                           -- p_observable in varchar2 - the name of the package that sent the event 
                                           -- p_event_type in varchar2 
                                           -- p_event_values in observer_pattern_helper.hashmap 
  ,  p_event_type in varchar2 default null -- when null, then observe all event types
  );

  
  procedure reg_val_fail_observer
  (  p_observer   in varchar2              -- name of a procedure that can be invoked to consume an event; its specification should be like 
                                           -- p_observable in varchar2 - the name of the package that sent the event 
                                           -- p_event_type in varchar2 
                                           -- p_event_values in observer_pattern_helper.hashmap 
  );

  procedure reg_perf_loss_observer
  (  p_observer   in varchar2              -- name of a procedure that can be invoked to consume an event; its specification should be like 
                                           -- p_observable in varchar2 - the name of the package that sent the event 
                                           -- p_event_type in varchar2 
                                           -- p_event_values in observer_pattern_helper.hashmap 
  );

  procedure reg_sal_decrease_observer
  (  p_observer   in varchar2              -- name of a procedure that can be invoked to consume an event; its specification should be like 
                                           -- p_observable in varchar2 - the name of the package that sent the event 
                                           -- p_event_type in varchar2 
                                           -- p_event_values in observer_pattern_helper.hashmap 
  );
  /* Logger interface:
     p_log_level in varchar2
   , p_log_origin in varchar2
   , p_log_message in varchar2
   */
  procedure set_logger (p_logger in varchar2);
  
  /* Emailer interface
     p_sender     in varchar2
   , p_recipient  in varchar2
   , p_header     in varchar2
   , p_message    in varchar2
   , p_importance in varchar2
  */
  procedure set_emailer (p_emailer in varchar2);


  procedure set_salessalarycap( p_salessalarycap in number);
  
  function verify_salary_raise( p_job in varchar2, p_old_salary in number, p_new_salary in number)
  return boolean;
  
  function verify_job_change( p_old_job in varchar2, p_new_job in varchar2)
  return boolean;

end HRM_SALARY_RULES;
/
