create or replace package Observer_Pattern_Helper is

  -- Author  : LUCAS_J
  -- Created : 3/10/2006 12:24:06 PM
  -- Purpose : Package with supporting objects for the Observer Pattern
 
 type observer_t is record 
  ( observer varchar2(120)
  , event_type varchar2(50)
  );
 type observer_table_t is table of observer_t;
  
 type hashmap is table of varchar2(500) index by varchar2(50);
 
 function key_value_string_to_hashmap
 ( p_string in varchar2
 ) return hashmap;
 
 procedure set_hashmap
 ( p_hashmap in hashmap
 );
 
 function get_hashmap
 return hashmap;
 
 procedure register_observer
( p_observer   in     varchar2              
, p_event_type in     varchar2 default null -- when null, then observe all event types  
, p_observers  in out observer_table_t
);

 procedure notify_observers
  ( p_event_type       in varchar2
  , p_event_parameters in hashmap
  , p_observable       in varchar2
  , p_observers        in observer_table_t
  );

end Observer_Pattern_Helper;
/
