create or replace package body PLSQL_DESIGNPATTERNS_TESTS is

 procedure print( p_text in varchar2)
 is
 begin
   dbms_output.put_line(p_text);
 end print;

 procedure test_whoami
 is
 begin
   print(plsql_reflection.who_am_i);
 end test_whoami;
 
 procedure test_hrm_salary_rules
 is
   procedure test_job_sal_raise
   ( p_job in varchar2
   , p_old_sal in number
   , p_new_sal in number
   ) is
   begin
     if hrm_salary_rules.verify_salary_raise(p_job => p_job,p_old_salary => p_old_sal ,p_new_salary => p_new_sal)
     then
       print( 'Salaryraise for '||p_job||'  from '||p_old_sal||' to '||p_new_sal||' is approved.'); 
     else
       print( 'Salaryraise for '||p_job||'  from '||p_old_sal||' to '||p_new_sal||' is NOT approved.');    
     end if;
   end;

 begin
   hrm_salary_rules.set_logger('LOGGER.LOG_MESSAGE');
   hrm_salary_rules.set_emailer('EMAILER_ADAPTER.SEND_EMAIL');
   dependency_injector.inject_dependencies;
   test_job_sal_raise('SALESMAN', 1000, 1020);
   test_job_sal_raise('SALESMAN', 1000, 1200);
 end test_hrm_salary_rules;

 procedure test_observer_pattern
 is
   procedure test_job_sal_raise
   ( p_job in varchar2
   , p_old_sal in number
   , p_new_sal in number
   ) is
   begin
     if hrm_salary_rules.verify_salary_raise(p_job => p_job,p_old_salary => p_old_sal ,p_new_salary => p_new_sal)
     then
       print( 'Salaryraise for '||p_job||'  from '||p_old_sal||' to '||p_new_sal||' is approved.'); 
     else
       print( 'Salaryraise for '||p_job||'  from '||p_old_sal||' to '||p_new_sal||' is NOT approved.');    
     end if;
   end;

 begin
   Performance_Monitor.set_logger('LOGGER.LOG_MESSAGE');
   hrm_salary_rules.set_logger('LOGGER.LOG_MESSAGE');
   hrm_salary_rules.reg_perf_loss_observer('PERFORMANCE_MONITOR.PERFORMANCE_LOSS_OBSERVER');
   test_job_sal_raise('SALESMAN', 1000, 1020);
   test_job_sal_raise('SALESMAN', 1000, 1200);
 end test_observer_pattern;

 
end PLSQL_DESIGNPATTERNS_TESTS;
/
